// Complex1.cpp : Defines the entry point for the console application.
// An electrical circuit has a resistance of 80 ohms
// an inductive reactance of 70 ohms and a capacitive
// reactance of 130 ohms connected in series.
// Determine the impedance of the circuit and the phase
// angle between the voltage and current.
// Results printed in both rectangular and polar formats. 
// Chris H. Pappas and William H. Murray, 2001

#include "stdafx.h"
#include <iostream>                
#include <complex>                

using namespace std;

int main(int argc, char* argv[])
{
    double pi = 3.14159265359;

    complex<double> x1, x2, x3, z1;

    // phasor one
    x1.real(80.0);        //resistor = 30.0 +j0.0 
    // phasor two
    x2.imag(70.0);        //ind react = 0.0 +j70.0
    // phasor three
    x3.imag(-130);        //cap react = 0.0 -j130
  
    // complex arithmetic calculation
    z1 = x1 + x2 + x3;            

    // results in rectangular form
    cout << "The answer in rectangular format is: "
         << z1 << endl << endl;
    // results in polar form
    cout << "The answer in polar format is: "
         << sqrt(norm(z1)) << " at /_ " << arg(z1) 
         << " radians (or " << arg(z1) * 180.0 / pi
         << " degrees)" << endl << endl;

	return 0;
}
