// Complex2View.cpp : implementation of the CComplex2View class
//

#include "stdafx.h"
#include "Complex2.h"

#include "Complex2Doc.h"
#include "Complex2View.h"

#include <complex>  
#include "Complex2View.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CComplex2View

IMPLEMENT_DYNCREATE(CComplex2View, CView)

BEGIN_MESSAGE_MAP(CComplex2View, CView)
    ON_WM_SIZE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComplex2View construction/destruction

CComplex2View::CComplex2View()
{
	// TODO: add construction code here

}

CComplex2View::~CComplex2View()
{
}

BOOL CComplex2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CComplex2View drawing

void CComplex2View::OnDraw(CDC* pDC)
{
	CComplex2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

    CPen bluepen, greenpen, magentapen, redpen;
    CPen* oldpen;

    complex<double> x1, x2, x3, temp;

    // phasor one
    x1 = polar(-50.0, -0.523598);   //-50.0 /_ -30 deg
    
    // phasor two
    x2.real(70.0);                  //70.0 + j40.0
    x2.imag(40.0);
    
    // phasor three
    x3.real(-40.0);                 //-40.0 + j50.0
    x3.imag(50.0);        
  
    // set mapping modes and viewport
    pDC->SetMapMode(MM_ISOTROPIC); 
    pDC->SetWindowExt(250, 250);
    pDC->SetViewportExt(m_cxClient, -m_cyClient);
    pDC->SetViewportOrg(m_cxClient / 2, m_cyClient / 2);

    // draw coordinate axes
    pDC->MoveTo(-120, 0);
    pDC->LineTo(120, 0);
    pDC->MoveTo(0, -100);
    pDC->LineTo(0, 100);

    // draw first phasor with blue pen
    bluepen.CreatePen(PS_DASHDOT, 0, RGB(0, 0, 255));
    oldpen = pDC -> SelectObject(&bluepen);
    pDC -> MoveTo(0, 0);
    pDC -> LineTo((int) real(x1), (int) imag(x1));
    DeleteObject(oldpen);

    temp = x1 + x2;  // add first two phasors

    // draw second phasor with green pen
    greenpen.CreatePen(PS_DASHDOT, 0, RGB(0, 255, 0));
    oldpen = pDC -> SelectObject(&greenpen);
    pDC -> LineTo((int) real(temp), (int) imag(temp));
    DeleteObject(oldpen);

    temp += x3;     // add in last phasor

    // draw third phasor with magenta pen
    magentapen.CreatePen(PS_DASHDOT, 0, RGB(255, 0, 255));
    oldpen = pDC -> SelectObject(&magentapen);
    pDC -> LineTo((int) real(temp), (int) imag(temp));
    DeleteObject(oldpen);

    // draw sum of phasors with wide red pen
    redpen.CreatePen(PS_SOLID, 3, RGB(255, 0, 0));
    oldpen = pDC -> SelectObject(&redpen);
    pDC -> LineTo(0, 0);
    DeleteObject(oldpen); 
}

/////////////////////////////////////////////////////////////////////////////
// CComplex2View diagnostics

#ifdef _DEBUG
void CComplex2View::AssertValid() const
{
	CView::AssertValid();
}

void CComplex2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CComplex2Doc* CComplex2View::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CComplex2Doc)));
	return (CComplex2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CComplex2View message handlers

void CComplex2View::OnSize(UINT nType, int cx, int cy)
{
    CView::OnSize(nType, cx, cy);

    m_cxClient = cx;
    m_cyClient = cy;
}
